clc; clear all; close all; fclose all;

%Input Image Size
HSIZE = 1080;
WSIZE = 1920;

%Database file list
Fid = textread('Data\StereoImageDatabaseListTest.txt','%s');

%Initialization for DAVI Feature Output
DAVI_FEATURE = zeros(size(Fid, 1), 15);

%Preallocation
DispMap = zeros(1080,1920);
SaleMap = zeros(HSIZE/4, WSIZE/4);
    
for MI = 1:1:size(Fid, 1)
    ImgName_cell = Fid(4*MI-3);
    DepthName_cell = Fid(4*MI-1);
    
    %Assign File Root to IEEE-SA Database location
    ImgName = ['E:\INSIGHT\2. \DB\S3D\IEEE-SA\StereoImageDataset\' cell2mat(ImgName_cell)];
    DepthName = ['Depth_information\' cell2mat(DepthName_cell)];
    Img = imread(ImgName, 'png');
    SaleFileName = [ImgName '_s.xls'];
    
    Fid_DispMap = fopen(DepthName); 
    Fid_SaleMap = fopen(SaleFileName);
    DispMap = fread(Fid_DispMap, [1080, 1920], 'double');
    for n=1:1:HSIZE/4
        for k=1:1:WSIZE/4
            SaleMap(n,k) = fscanf(Fid_SaleMap, '%f',1);
        end
    end
    fclose(Fid_DispMap);
    fclose(Fid_SaleMap);

    imagesc(DispMap);axis image;colormap gray; title('Disparity map');

    
    %% DAVI
    DAVIFeatures1 = fn_DAVIFeatureExtraction1(DispMap);
    DAVIFeatures2 = fn_DAVIFeatureExtraction2(DispMap);

    DAVI_FEATURE(MI, :)  = [DAVIFeatures1 DAVIFeatures2];
    
end

dlmwrite('DAVI_feature.txt', DAVI_FEATURE);
